#<profile4xi profile = "31"/>
#<program4xi program = "walk2replace4app.py">
#<abstract4xi abstract = "walks through HTML files of spefied directory and its subdirectories replacing file content as required"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "copy first output to input, then delete all html files in output - directories are not created for you"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'walk2replace4app' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi      # from lutiprocessing4xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug
global count2skipped
global count2replaced
global count2total
global file2output
global kb2search                             # knowledgebase for searching
global keys2search
global keys2replace
global keys2search
global kb2replace                            # knowledgebase for replacing
global keys2replace
global name2create
global path2temp4source  
global path2read4xi                          # path for input source targets
global path2write4xi                         # path for output source targets
global PickleKB4Xi
global profile2fetch                         # extension for files
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False    # turn on/off 
file2output = None
count2skipped = 0
count2replaced = 0
count2total = 0                                                                                            
kb2search = {}
kb2replace = {}


# -----------------------------------------------------------------------------
# kb2search
# -----------------------------------------------------------------------------

# --------
# RUN 28 / - can be run only to modify email_notice
# --------
kb2search [1]='law of the the European Union.'


# --------
# RUN 27 / - can be run to all; modifies only those index.html preventing access to directories
# --------
# kb2search [1]='<body bgcolor="#000000" text="#555555">'

# --------
# RUN 26 
# --------
# kb2search  [1]='<br /><h3>'
# kb2search  [2]='<br /> <h3>'
# kb2search  [3]='<br />  <h3>'
# kb2search  [4]='<br />   <h3>'
# kb2search  [5]='<br />    <h3>'
# kb2search  [6]='<br />     <h3>'
# kb2search  [7]='<br />      <h3>'
# kb2search  [8]='<br />       <h3>'
# kb2search  [9]='<br />        <h3>'
# kb2search [10]='<br />         <h3>'
# kb2search [11]='<br />          <h3>'
# kb2search [12]='<br />           <h3>'
# kb2search [13]='<br />            <h3>'
# kb2search [14]='<br />             <h3>'
# kb2search [15]='<br />              <h3>'
# kb2search [16]='<br />               <h3>'
# kb2search [17]='<br />                <h3>'
# kb2search [18]='<br />                 <h3>'
# kb2search [19]='<br />                  <h3>'
# kb2search [20]='<br />                   <h3>'
# kb2search [21]='<br />                    <h3>'

# --------
# RUN 25 
# --------
# kb2search [1]='<br /><b>[A]</b>'
# kb2search [2]='<br /><b>[P]</b>'

# --------
# RUN 24 
# --------
# kb2search [1]='<b>&Xi;</b> email #<sub>1</sub>'
# kb2search [2]='<b>&Xi;</b> email #<sub>2</sub>'
# kb2search [3]='<b>&Xi;</b> email #<sub>3</sub>'
# kb2search [4]='<b>&Xi;</b> email #<sub>4</sub>'
# kb2search [5]='<b>&Xi;</b> email #<sub>5</sub>'
# kb2search [6]='<b>&Xi;</b> email #<sub>6</sub>'
# kb2search [7]='<b>&Xi;</b> email #<sub>7</sub>'
# kb2search [8]='<b>&Xi;</b> email #<sub>8</sub>'
# kb2search [9]='<b>&Xi;</b> email #<sub>9</sub>'


# --------
# RUN 23 
# --------
# kb2search [1]='Copyright 2019'

# --------
# RUN 22 
# --------
# kb2search [1]='alt="DragonXi"'
# kb2search [2]='alt="NET Business"'
# kb2search [3]='alt="Pod Business"'
# kb2search [4]='alt="Xi Business"'
# kb2search [5]='alt="NET Patrol"'
# kb2search [6]='alt="Pod Patrol"'
# kb2search [7]='alt="Xi Patrol"'
# kb2search [8]='alt="NET Military"'
# kb2search [9]='alt="Pod Military"'
# 
# kb2search [10]='alt="Xi Military"'
# kb2search [11]='alt="Base Business"'
# kb2search [12]='alt="Base Patrol"'
# kb2search [13]='alt="Base Military"'
# kb2search [14]='alt="Sensor Business"'
# kb2search [15]='alt="Sensor Patrol"'
# kb2search [16]='alt="Sensor Military"'
# kb2search [17]='alt="H2RD" '
# kb2search [18]='alt="PRD4B"'
# kb2search [19]='alt="PRD4P"'
# 
# kb2search [20]='alt="PRD4W"'
# kb2search [21]='alt="2H2FD4B"'
# kb2search [22]='alt="2H2FD4P"'
# kb2search [23]='alt="2H2FD4W"'
# kb2search [24]='alt="Sphere DragonXi"'
# kb2search [25]='alt="Surfer DragonXi"'
# kb2search [26]='alt="Icon CBO"'
# kb2search [27]='alt="Icon CCO"'
# kb2search [28]='alt="Icon CDO"'
# kb2search [29]='alt="Icon CEO"'
# 
# kb2search [30]='alt="Icon CFO"'
# kb2search [31]='alt="Icon CMO"'
# kb2search [32]='alt="Icon CPO"'
# kb2search [33]='alt="Icon CTO"'
# kb2search [34]='alt="Icon SEC"'
# kb2search [35]='alt="Golden Gate"'

# --------
# RUN 21 - 27 Nov 2019
# --------
# kb2search [1]='<html>'
# kb2search [2]='<title>Legal Notice</title>'
# kb2search [3]='<body>'
# kb2search [4]='</html>'
# kb2search [5]='<style type="text/css" media="all">'
# kb2search [6]='<div align="justify"><strong>'
# kb2search [7]='</strong></div>'
# kb2search [8]='<p align="justify"><b>'
# kb2search [9]='</b></p>'
# kb2search [10]='<p align="justify">'
# kb2search [11]='Small'
# kb2search [12]='must'
# kb2search [13]='sectors'
# kb2search [14]='s International' 

# --------
# RUN 20 - 25 Nov 2019
# --------
# kb2search [1]='<img src="spec/images/png/surfer.png" alt="Surfer DragonXi" height="150" width="150" align="center" hspace="33" vspace="33" /></a>'
# kb2search [2]='<img src="spec/images/png/xi_bus_04.png" alt="Xi Business" height="200" width="210" align="center" hspace="150" vspace="33" /></a>'
# kb2search [3]='<img src="spec/images/png/xi_pat_07.png" alt="Xi Patrol" height="200" width="210" align="center" hspace="150" vspace="33" /></a>'
# kb2search [4]='<img src="spec/images/png/xi_mil_01.png" alt="Xi Military" height="200" width="210" align="center" hspace="150" vspace="33" /></a>'
# kb2search [5]='<img src="spec/images/png/base_bus_03.png" alt="Base Business" height="200" width="210" align="center" hspace="150" vspace="33" /></a>'
# kb2search [6]='<img src="spec/images/png/base_pat_02.png" alt="Base Patrol" height="200" width="210" align="center" hspace="150" vspace="33" /></a>'
# kb2search [7]='<img src="spec/images/png/base_mil_01.png" alt="Base Military" height="200" width="210" align="center" hspace="150" vspace="33" /></a>'
# kb2search [8]='<img src="spec/images/jpg/2h2fd4b_r.jpg" alt="2H2FD4B" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'



# --------
# RUN 19 - 25 Nov 2019
# --------
# kb2search [1]='<img src="spec/images/jpg/2h2fd4b_r.jpg" alt="2H2FD4B" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'

# --------
# RUN 18 - for app2ace4yo.app only ! 25 Nov 2019
# --------
# kb2search [1]='<br /><b>&Gamma;</b> <b>Autonomous & Unmanned</b>'
# kb2search [2]='<br />      <h3><b>&Phi;</b> Deep Technology</h3>'
# kb2search [3]='<br /><b>['
# kb2search [4]=']</b>'


# --------
# RUN 17 - for app2ace4yo.app only ! 25 Nov 2019
# --------
# kb2search [1]='<img src="spec/images/jpg/xiball1.jpg" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [2]='<img src="spec/images/jpg/xiball2.jpg" alt="Sphere DragonXi" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [3]='<img src="spec/images/jpg/xiball3.jpg" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [4]='<img src="spec/images/jpg/xiball4.jpg" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [5]='<img src="spec/images/jpg/xiball5.jpg" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [6]='<img src="spec/images/jpg/xiball6.jpg" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [7]='<img src="spec/images/jpg/xiball7.jpg" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [8]='<img src="spec/images/jpg/xiball8.jpg" height="150" width="150" align="center" hspace="100" vspace="33" />'


# --------
# RUN 16 - kept as they were because HTML5 has bugs and therefore https://html5.validator.nu/ marks them as errors
# --------
# kb2search [1]='<meta charset="UTF-8">'
# kb2search [2]='<link rel="shortcut icon" href="dragonxi.ico" >'

# --------
# RUN 15 
# --------
# kb2search [1]='<img src="spec/images/png/dragonxi.png" alt="DragonXi" height="210" width="420" align="center" hspace="100" vspace="33" /></a>'
# kb2search [2]='<img src="spec/images/png/net_business.png" alt="NET Business" height="239" width="420" align="center" hspace="100" vspace="33" /></a>'
# kb2search [3]='<img src="spec/images/png/pod_bus_01.png" alt="Pod Business" height="150" width="200" align="center" hspace="150" vspace="33" />'
# kb2search [4]='<img src="spec/images/png/xi_bus_04.png" alt="Xi Business" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [5]='<img src="spec/images/png/net_patrol.png" alt="NET Patrol" height="239" width="420" align="center" hspace="100" vspace="33" /></a>'
# kb2search [6]='<img src="spec/images/png/pod_pat_01.png" alt="Pod Patrol" height="150" width="200" align="center" hspace="150" vspace="33" />'
# kb2search [7]='<img src="spec/images/png/xi_pat_07.png" alt="Xi Patrol" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [8]='<img src="spec/images/png/net_military.png" alt="NET Military" height="239" width="420" align="center" hspace="100" vspace="33" /></a>'
# kb2search [9]='<img src="spec/images/png/pod_mil_01.png" alt="Pod Military" height="150" width="200" align="center" hspace="150" vspace="33" />'
# # 
# kb2search [10]='<img src="spec/images/png/xi_mil_01.png" alt="Xi Military" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [11]='<img src="spec/images/png/base_bus_03.png" alt="Base Business" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [12]='<img src="spec/images/png/base_pat_02.png" alt="Base Patrol" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [13]='<img src="spec/images/png/base_mil_01.png" alt="Base Military" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [14]='<img src="spec/images/png/sensor_bus_01.png" alt="Sensor Business" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [15]='<img src="spec/images/png/sensor_pat_01.png" alt="Sensor Patrol" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [16]='<img src="spec/images/png/sensor_mil_01.png" alt="Sensor Military" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [17]='<img src="spec/images/jpg/h2rd_l.jpg" alt="H2RD" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [18]='<img src="spec/images/jpg/h2rd_f.jpg" alt="H2RD" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [19]='<img src="spec/images/jpg/h2rd_r.jpg" alt="H2RD" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# # 
# kb2search [20]='<img src="spec/images/jpg/prd4b_l.jpg" alt="PRD4B" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [21]='<img src="spec/images/jpg/prd4p_p.jpg" alt="PRD4P" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [22]='<img src="spec/images/jpg/prd4w_p.jpg" alt="PRD4W" height="150" width="200" align="center" hspace="150" vspace="33" /></a>'
# kb2search [23]='<img src="spec/images/jpg/2h2fd4b_r.jpg" alt="2H2FD4B" height="120" width="160" align="center" hspace="150" vspace="33" /></a>'
# kb2search [24]='<img src="spec/images/jpg/2h2fd4p_f.jpg" alt="2H2FD4P" height="120" width="160" align="center" hspace="150" vspace="33" /></a>'
# kb2search [25]='<img src="spec/images/jpg/2h2fd4w_l.jpg" alt="2H2FD4W" height="120" width="160" align="center" hspace="150" vspace="33" /></a>'
# kb2search [26]='<img src="spec/images/jpg/xiball1.jpg" alt="Sphere DragonXi" height="150" width="150" align="center" hspace="150" vspace="33" /><h3><b>&xi;</b> Multiprocessing4Xi</h3>'
# kb2search [27]='<img src="spec/images/jpg/xiball2.jpg" alt="Sphere DragonXi" height="150" width="150" align="center" hspace="150" vspace="33" /><h3><b>&xi;</b> Scope4xi</h3>'
# kb2search [28]='<img src="spec/images/jpg/xiball3.jpg" alt="Sphere DragonXi" height="150" width="150" align="center" hspace="150" vspace="33" /><h3><b>&xi;</b> Studio4xi</h3>'
# kb2search [29]='<img src="spec/images/png/surfer.png" alt="Surfer DragonXi" height="150" width="150" align="center" hspace="50" vspace="33" /></a>'
# # 
# kb2search [30]='<br /><img src="spec/images/jpg/xiball1.jpg" alt="Sphere DragonXi" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [31]='<br /><img src="spec/images/jpg/xiball3.jpg" alt="Sphere DragonXi" height="150" width="150" align="center" hspace="100" vspace="33" />'
# kb2search [32]='<img src="spec/images/jpg/xi_icons_cbo.jpg" alt="Icon CBO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [33]='<img src="spec/images/jpg/xi_icons_cco.jpg" alt="Icon CCO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [34]='<img src="spec/images/jpg/xi_icons_cdo.jpg" alt="Icon CDO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [35]='<img src="spec/images/jpg/xi_icons_ceo.jpg" alt="Icon CEO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [36]='<img src="spec/images/jpg/xi_icons_cfo.jpg" alt="Icon CFO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [37]='<img src="spec/images/jpg/xi_icons_cmo.jpg" alt="Icon CMO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [38]='<img src="spec/images/jpg/xi_icons_cpo.jpg" alt="Icon CPO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [39]='<img src="spec/images/jpg/xi_icons_cto.jpg" alt="Icon CTO" height="100" width="73" align="center" hspace="33" vspace="33" />'
# # 
# kb2search [40]='<img src="spec/images/jpg/xi_icons_sec.jpg" alt="Icon SEC" height="100" width="73" align="center" hspace="33" vspace="33" />'
# kb2search [41]='<img src="spec/images/png/dragonxi.png" alt="DragonXi" height="105" width="210" align="center" hspace="33" vspace="33" /></a>'
# kb2search [42]='<img src="spec/images/jpg/goldengate.jpg" alt="Golden Gate" height="124" width="210" align="center" hspace="33" vspace="33" /></a>'


# --------
# RUN 14 
# --------
# kb2search [1]='<h3> <b>&xi;</b> <b>Contact to learn more:</h3>'

# --------
# RUN 13 
# --------
# kb2search [1]='<br /> <b>&xi;</b> <b>Contact examples to learn more:</b>'

# --------
# RUN 12 
# --------
# kb2search [1]='<img src="spec/images/png/dragonxi.png"'
# kb2search [2]='<img src="spec/images/png/net_business.png"'
# kb2search [3]='<img src="spec/images/png/pod_bus_01.png"'
# kb2search [4]='<img src="spec/images/png/xi_bus_04.png"'
# kb2search [5]='<img src="spec/images/png/net_patrol.png"'
# kb2search [6]='<img src="spec/images/png/pod_pat_01.png"'
# kb2search [7]='<img src="spec/images/png/xi_pat_07.png"'
# kb2search [8]='<img src="spec/images/png/net_military.png"'
# kb2search [9]='<img src="spec/images/png/pod_mil_01.png"'
# 
# kb2search [10]='<img src="spec/images/png/xi_mil_01.png"'
# kb2search [11]='<img src="spec/images/png/base_bus_03.png"'
# kb2search [12]='<img src="spec/images/png/base_pat_02.png"'
# kb2search [13]='<img src="spec/images/png/base_mil_01.png"'
# kb2search [14]='<img src="spec/images/png/sensor_bus_01.png"'
# kb2search [15]='<img src="spec/images/png/sensor_pat_01.png"'
# kb2search [16]='<img src="spec/images/png/sensor_mil_01.png"'
# kb2search [17]='<img src="spec/images/jpg/h2rd_l.jpg"'
# kb2search [18]='<img src="spec/images/jpg/h2rd_f.jpg"'
# kb2search [19]='<img src="spec/images/jpg/h2rd_r.jpg"'
# 
# kb2search [20]='<img src="spec/images/jpg/prd4b_l.jpg"'
# kb2search [21]='<img src="spec/images/jpg/prd4p_p.jpg"'
# kb2search [22]='<img src="spec/images/jpg/prd4w_p.jpg"'
# kb2search [23]='<img src="spec/images/jpg/2h2fd4b_r.jpg"'
# kb2search [24]='<img src="spec/images/jpg/2h2fd4p_f.jpg"'
# kb2search [25]='<img src="spec/images/jpg/2h2fd4w_l.jpg"'
# kb2search [26]='<img src="spec/images/jpg/xiball1.jpg"'
# kb2search [27]='<img src="spec/images/jpg/xiball2.jpg"'
# kb2search [28]='<img src="spec/images/jpg/xiball3.jpg"'
# kb2search [29]='<img src="spec/images/png/surfer.png"'
# 
# kb2search [30]='<img src="spec/images/jpg/xi_icons_cbo.jpg"'
# kb2search [31]='<img src="spec/images/jpg/xi_icons_cco.jpg"'
# kb2search [32]='<img src="spec/images/jpg/xi_icons_cdo.jpg"'
# kb2search [33]='<img src="spec/images/jpg/xi_icons_ceo.jpg"'
# kb2search [34]='<img src="spec/images/jpg/xi_icons_cfo.jpg"'
# kb2search [35]='<img src="spec/images/jpg/xi_icons_cmo.jpg"'
# kb2search [36]='<img src="spec/images/jpg/xi_icons_cpo.jpg"'
# kb2search [37]='<img src="spec/images/jpg/xi_icons_cto.jpg"'
# kb2search [38]='<img src="spec/images/jpg/xi_icons_sec.jpg"'
# kb2search [39]='<img src="spec/images/jpg/goldengate.jpg"'
# 
# kb2search [40]='<br /> <b>&xi;</b> <b>Contact examples to learn more:</b></a>'

# --------
# RUN 11 - Three UNIQUE POINT TO SEARCH
# --------
# kb2search [1]='<b>&zeta;</b><sub>b</sub>'
# kb2search [2]='<b>&zeta;</b><sub>p</sub>'
# kb2search [3]='<b>&zeta;</b><sub>m</sub>'

# --------
# RUN 10 - UNIQUE POINT TO SEARCH
# --------
# kb2search [1]='<br /><h3><b>&epsilon;</b> Quantum Computing'

# --------
# RUN 9 - UNIQUE POINT TO SEARCH
# --------
# kb2search [1]='</sub></a>'

# --------
# RUN 8 - UNIQUE POINT TO SEARCH
# --------
# kb2search [1]='height="150" height="200"'

# --------
# RUN 7 - UNIQUE POINT TO SEARCH
# --------
# kb2search [1]='</head>'

# --------
# RUN 6 - UNIQUE POINT TO SEARCH
# --------
# kb2search [1]='<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />'

# --------
# RUN 5 - UNIQUE POINT TO SEARCH
# --------
# kb2search [1]='</style>'

# --------
# RUN 4 - 19 UNIQUE POINTS TO SEARCH
# --------
# kb2search [1]='<br /><!--'
# kb2search [2]='<br /><b>Categories</b>' 
# kb2search [3]='<br /><b>&xi;</b> Multiprocessing4Xi'
# kb2search [4]='<br /><b>&xi;</b> Scope4xi'
# kb2search [5]='<br /><b>&xi;</b> Studio4xi'
# kb2search [6]='<br /><b>&tau;</b> <b>Artificial Intelligence (AI)</b>'
# kb2search [7]='<br /><b>&Gamma;</b> <b>Autonomous</b>'
# kb2search [8]='<br /><b>&Phi;</b> <b>Deep Technology</b>'
# kb2search [9]='<br /> <b>&Psi;</b> <b>Ocean, Desert, Tepui, Environment</b></a>'
# kb2search [10]='<br /> <b>&nu;</b> <b>Fishing and hunting</b>'
# kb2search [11]='<br /> <b>&epsilon;</b> <b>Quantum Computing</b>'
# kb2search [12]='<br /> <b>&Pi;</b> <b>Science</b></a>'
# kb2search [13]='<br /> <b>&upsilon;</b> <b>Special Vehicles</b></a>'
# kb2search [14]='<br /> <b>&rho;</b> <b>Unmanned</b>'
# kb2search [15]='<br /> <b>&chi;</b> <b>Various</b>'
# kb2search [16]='<br /> <b>&delta;</b> <b>Wearable</b>'
# kb2search [17]='<br /><b>All in alphabetical order</b>'
# kb2search [18]='<br /><b>&xi;</b>'
# kb2search [19]='<b>&raquo;</b><a href="https://www.machineprogramming.dev" target="_blank">.dev</a>'
# kb2search [20]='<!-- start of upgrade#3, 1st of Nov 19 -->'
# kb2search [21]='<!-- end of upgrade#3, 1st of Nov 19 -->'
# kb2search [22]='<!-- start of upgrade#1, 1st of Nov 19 -->'
# kb2search [23]='<!-- end of upgrade#1, 1st of Nov 19 -->'
# kb2search [24]='<!-- start of upgrade#4, 1st of Nov 19 -->'
# kb2search [25]='<!-- end of upgrade#4, 1st of Nov 19 -->'

# kb2search [22]='<br /><b>['
# kb2search [23]=']</b>'
# kb2search [24]='<br /><img src='
# kb2search [25]='<br /> <b>&xi;</b> <b>Contact examples to learn more:</b></a>'
# kb2search [26]='<br />'

# 5 set:
# kb2search [1]='Systems'

# 4 set:
# kb2replace[1]=' @import "../css/halongbay.css";'
# kb2replace[2]=' '
# kb2replace[3]='https://'
# kb2replace[4]='width="210" '
# kb2replace[5]='height="105" '
# kb2replace[6]='legal_notice.html'
# kb2replace[7]='dragonxi.dev/" target="_blank">dragonxi.dev</a>'
# kb2replace[8]=' <b>&raquo;</b>'
# kb2replace[9]='yourdragonxi.org</a>'
# kb2replace[10]='<b>&raquo;</b><a href="https://www.senseit.app" target="_blank">Sense it.</a>'
# kb2replace[11]='<b>&raquo;</b><a href="https://www.reasonit.app" target="_blank">Reason it.</a>'
# kb2replace[12]='<b>&raquo;</b><a href="https://www.aceit.app" target="_blank">Ace it</a>'
# kb2replace[13]='with <a href="https://www.dragonxi.app" target="_blank"><b>DragonXi</b></a><sup>&trade;</sup>!'

# 3 set: E:\DRAGONXI\PC4Xi\app2ace4yo_app\index.html to be fixed in all others
#        G:\temp\job2studio4xi\in\html\aceit_dev\index.html <-- one test input
# note:  expected to replace in the following order
#        see path2read4xi
#

# 2 set 
# kb2search [1]='DragonXi | Artificial Intelligence | AI |'
# kb2search [2]='dragonxi.com'
# kb2search [3]='personalrobot'

# 1 set                                                        
# kb2search [1]='http://www.yourdragonxi'
# kb2search [2]='http:/www.yourdragonxi'
# kb2search [3]='http:www.yourdragonxi'



# -----------------------------------------------------------------------------
# kb2replace
# -----------------------------------------------------------------------------

# --------
# RUN 28  
# --------
kb2replace [1]='law of the the European Union.' + '\n' + '</td>' + '\n'

# --------
# RUN 27  
# --------
# kb2replace [1]='<body>'

# --------
# RUN 26 
# --------
# kb2replace [1]='<h3>'
# kb2replace [2]='<h3>'
# kb2replace [3]='<h3>'
# kb2replace [4]='<h3>'
# kb2replace [5]='<h3>'
# kb2replace [6]='<h3>'
# kb2replace [7]='<h3>'
# kb2replace [8]='<h3>'
# kb2replace [9]='<h3>'
# kb2replace [10]='<h3>'
# kb2replace [11]='<h3>'
# kb2replace [12]='<h3>'
# kb2replace [13]='<h3>'
# kb2replace [14]='<h3>'
# kb2replace [15]='<h3>'
# kb2replace [16]='<h3>'
# kb2replace [17]='<h3>'
# kb2replace [18]='<h3>'
# kb2replace [19]='<h3>'
# kb2replace [20]='<h3>'
# kb2replace [21]='<h3>'

# --------
# RUN 25 
# --------
# kb2replace [1] = '<br /><b>[A]</b>' + '\n' 
# kb2replace [1] = kb2replace [1] + '</td>' + '\n' + '</tr>' + '\n'
# kb2replace [1] = kb2replace [1] + '<!-- =============================================================================================================== -->' + '\n'
# kb2replace [1] = kb2replace [1] + '<tr>' + '\n'  + '  <td>' + '\n'
# kb2replace [1] = kb2replace [1] + '       <b>&Delta;</b> atlanticocean' + '\n'
# kb2replace [1] = kb2replace [1] + '       <b>&raquo;</b><a href="https://atlanticocean.app/" target="_blank">.app</a>' + '\n'
# kb2replace [1] = kb2replace [1] + '       <b>&raquo;</b><a href="https://atlanticocean.dev/" target="_blank">.dev</a>' + '\n'
# 
# kb2replace [2] = '<br /><b>[P]</b>' + '\n' 
# kb2replace [2] = kb2replace [2] + '</td>' + '\n' + '</tr>' + '\n'
# kb2replace [2] = kb2replace [2] + '<!-- =============================================================================================================== -->' + '\n'
# kb2replace [2] = kb2replace [2] + '<tr>' + '\n'  + '  <td>' + '\n'
# kb2replace [2] = kb2replace [2] + '       <b>&Delta;</b> pacificocean' + '\n'
# kb2replace [2] = kb2replace [2] + '       <b>&raquo;</b><a href="https://pacificocean.app/" target="_blank">.app</a>' + '\n'
# kb2replace [2] = kb2replace [2] + '       <b>&raquo;</b><a href="https://pacificocean.dev/" target="_blank">.dev</a>' + '\n'

# --------
# RUN 24 
# --------
# kb2replace [1]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>1</sub></a>'
# kb2replace [2]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>2</sub></a>'
# kb2replace [3]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>3</sub></a>'
# kb2replace [4]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>4</sub></a>'
# kb2replace [5]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>5</sub></a>'
# kb2replace [6]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>6</sub></a>'
# kb2replace [7]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>7</sub></a>'
# kb2replace [8]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>8</sub></a>'
# kb2replace [9]= '<b>&Xi;</b> <b>&raquo;</b> <a href="spec/legal/email_notice.html" target="_blank">email #<sub>9</sub></a>'


# --------
# RUN 23 
# --------
# kb2replace [1]= 'Copyright 2020'


# --------
# RUN 22 
# --------
# kb2replace [1]='alt="DragonXi Unmanned Autonomous System (UAS) powered by Artificial Intelligence (AI)" '
# kb2replace [2]='alt="Network (NET) for Business powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [3]='alt="Pod powered by Artificial Intelligence (AI) for Business Unmanned Autonomous System (UAS) with DragonXi UAV" '
# kb2replace [4]='alt="DragonXi Unmanned Autonomous Vehicle (UAV) for Business powered by Artificial Intelligence (AI )" '
# kb2replace [5]='alt="Network (NET) for Patrol powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [6]='alt="Pod powered by Artificial Intelligence (AI) for Patrol Unmanned Autonomous System (UAS) with DragonXi UAV" '
# kb2replace [7]='alt="DragonXi Unmanned Autonomous Vehicle (UAV) for Patrol powered by Artificial Intelligence (AI)" '
# kb2replace [8]='alt="Network (NET) for Military powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [9]='alt="Pod powered by Artificial Intelligence (AI) for Military Unmanned Autonomous System (UAS) with DragonXi UAV" '
# 
# kb2replace [10]='alt="DragonXi Unmanned Autonomous Vehicle (UAV) for Military powered by Artificial Intelligence (AI)" '
# kb2replace [11]='alt="Base Station for DragonXi UAV powered by Artificial Intelligence (AI) for Business Unmanned Autonomous System (UAS)" '
# kb2replace [12]='alt="Base Station for DragonXi UAV powered by Artificial Intelligence (AI) for Patrol Unmanned Autonomous System (UAS)" '
# kb2replace [13]='alt="Base Station for DragonXi UAV powered by Artificial Intelligence (AI) for Military Unmanned Autonomous System (UAS)" '
# kb2replace [14]='alt="Sensor powered by Artificial Intelligence (AI) for Business Unmanned Autonomous System (UAS)" '
# kb2replace [15]='alt="Sensor powered by Artificial Intelligence (AI) for Patrol Unmanned Autonomous System (UAS)" '
# kb2replace [16]='alt="Sensor powered by Artificial Intelligence (AI) for Military Unmanned Autonomous System (UAS)" '
# kb2replace [17]='alt="Hydrogen (H2) Fuel Cell (MH2) powered Resource Device (H2RD) for DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [18]='alt="Pocket Rollable Display for Business (PRD4B) powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [19]='alt="Pocket Rollable Display for Patrol (PRD4P) powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [20]='alt="Pocket Rollable Display (PRD4W) for Warrior powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [21]='alt="Mobile Device for Business (2H2FD4B) powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [22]='alt="Mobile Device for Patrol (2H2FD4P) powered by Artificial Intelligence (AI) and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [23]='alt="Mobile Device for Warrior (2H2FD4W) powered by Artificial Intelligence (AI)and DragonXi Unmanned Autonomous System (UAS)" '
# kb2replace [24]='alt="Sphere of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [25]='alt="Surfer of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [26]='alt="Chief BIO (CBO) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [27]='alt="Chief Creative (CCO) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [28]='alt="Chief Design (CDO) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [29]='alt="Chief Executive(CEO) of DragonXi powered by Artificial Intelligence (AI)" '
# 
# kb2replace [30]='alt="Chief Financial (CFO) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [31]='alt="Chief Marketing (CMO) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [32]='alt="Chief Production (CPO) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [33]='alt="Chief Technology (CTO) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [34]='alt="Secretary (SEC) of DragonXi powered by Artificial Intelligence (AI)" '
# kb2replace [35]='alt="Golden Gate Bridge" '

# --------
# RUN 21 
# --------
# kb2replace [1]='<html>' + '\n' + '<head>' + '\n' + '<meta charset="UTF-8">' + '\n'+ '<title>Legal Notice</title>'
# kb2replace [2]=' ' + '\n'
# kb2replace [3]='</head> ' + '\n' + '<body>' + '\n'
# kb2replace [4]='</body>' + '\n' + '</html>' + '\n'
# kb2replace [5]='<title>Legal Notice</title>' + '\n' + '<style type="text/css" media="all">'
# kb2replace [6]='<h3>'
# kb2replace [7]='</h3>'
# kb2replace [8]='<p>'
# kb2replace [9]='</p>'
# kb2replace [10]='<p>'
# kb2replace [11]='&copy;' + 'Small'
# kb2replace [12]=' must'
# kb2replace [13]='sectors '
# kb2replace [14]=' International' 

# --------
# RUN 20 
# --------
# kb2replace [1]='<div class="set2surfer4xi"><img src="spec/images/png/surfer.png" alt="Surfer DragonXi" height="150" width="150" /></div></a>'
# kb2replace [2]='<div class="set2copter4xi"><img src="spec/images/png/xi_bus_04.png" alt="Xi Business" height="150" width="200" /></div></a>'
# kb2replace [3]='<div class="set2copter4xi"><img src="spec/images/png/xi_pat_07.png" alt="Xi Patrol" height="150" width="200" /></div></a>'
# kb2replace [4]='<div class="set2copter4xi"><img src="spec/images/png/xi_mil_01.png" alt="Xi Military" height="150" width="200" /></div></a>'
# kb2replace [5]='<div class="set2base4xi"><img src="spec/images/png/base_bus_03.png" alt="Base Business" height="150" width="200" /></div></a>'
# kb2replace [6]='<div class="set2base4xi"><img src="spec/images/png/base_pat_02.png" alt="Base Patrol" height="150" width="200" /></div></a>'
# kb2replace [7]='<div class="set2base4xi"><img src="spec/images/png/base_mil_01.png" alt="Base Military" height="150" width="200" /></div></a>'
# kb2replace [8]='<div class="set2h2fd4xi"><img src="spec/images/jpg/2h2fd4b_r.jpg" alt="2H2FD4B" height="150" width="200" /></div></a>'


# --------
# RUN 19 
# --------
# kb2replace[1]='<div class="set2h2fd4xi"><img src="spec/images/jpg/2h2fd4b_r.jpg" alt="2H2FD4B" height="150" width="200" /></div></a>'

# --------
# RUN 18 - for app2ace4yo only 25 Nov 2019
# --------
# kb2replace[1]='    <h3><b>&Gamma;</b> <b>Autonomous & Unmanned</h3>'
# kb2replace[2]='          <h3><b>&Phi;</b> Deep Technology</h3>'
# kb2replace[3]='<h3>['
# kb2replace[4]=']</h3>'


# --------
# RUN 17 - for app2ace4yo only 25 Nov 2019
# --------
# 
# kb2replace [1]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball1.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [2]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball2.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [3]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball3.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [4]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball4.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [5]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball5.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [6]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball6.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [7]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball7.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [8]='<div class="set2sphere4xi"><img src="spec/images/jpg/xiball8.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'


# --------
# RUN 16 - kept as they were because HTML5 has bugs and therefore https://html5.validator.nu/ marks them as errors
# --------
# kb2replace [1]='<meta charset="UTF-8">'
# kb2replace [2]='<link rel="shortcut icon" href="dragonxi.ico" >'

# --------
# RUN 15
# --------
# kb2replace [1] = '<div class="set2logo4xi"><img src="spec/images/png/dragonxi.png" alt="DragonXi" height="210" width="420" /></div></a>'
# kb2replace [2] = '<div class="set2net4xi"><img src="spec/images/png/net_business.png" alt="NET Business" height="239" width="420" /></div></a>'
# kb2replace [3] = '<div class="set2pod4xi"><img src="spec/images/png/pod_bus_01.png" alt="Pod Business" height="150" width="200" /></div>'
# kb2replace [4] = '<div class="set2copter4xi"><img src="spec/images/png/xi_bus_04.png" alt="Xi Business" height="150" width="200" /></div></a>'
# kb2replace [5] = '<div class="set2net4xi"><img src="spec/images/png/net_patrol.png" alt="NET Patrol" height="239" width="420" /></div></a>'
# kb2replace [6] = '<div class="set2pod4xi"><img src="spec/images/png/pod_pat_01.png" alt="Pod Patrol" height="150" width="200" /></div>'
# kb2replace [7] = '<div class="set2copter4xi"><img src="spec/images/png/xi_pat_07.png" alt="Xi Patrol" height="150" width="200" /></div></a>'
# kb2replace [8] = '<div class="set2net4xi"><img src="spec/images/png/net_military.png" alt="NET Military" height="239" width="420" /></div></a>'
# kb2replace [9] = '<div class="set2pod4xi"><img src="spec/images/png/pod_mil_01.png" alt="Pod Military" height="150" width="200" /></div>'
# # 
# kb2replace [10] = '<div class="set2copter4xi"><img src="spec/images/png/xi_mil_01.png" alt="Xi Military" height="150" width="200" /></div></a>'
# kb2replace [11] = '<div class="set2base4xi"><img src="spec/images/png/base_bus_03.png" alt="Base Business" height="150" width="200" /></div></a>'
# kb2replace [12] = '<div class="set2base4xi"><img src="spec/images/png/base_pat_02.png" alt="Base Patrol" height="150" width="200" /></div></a>'
# kb2replace [13] = '<div class="set2base4xi"><img src="spec/images/png/base_mil_01.png" alt="Base Military" height="150" width="200" /></div></a>'
# kb2replace [14] = '<div class="set2sensor4xi"><img src="spec/images/png/sensor_bus_01.png" alt="Sensor Business" height="150" width="200" /></div></a>'
# kb2replace [15] = '<div class="set2sensor4xi"><img src="spec/images/png/sensor_pat_01.png" alt="Sensor Patrol" height="150" width="200" /></div></a>'
# kb2replace [16] = '<div class="set2sensor4xi"><img src="spec/images/png/sensor_mil_01.png" alt="Sensor Military" height="150" width="200" /></div></a>'
# kb2replace [17] = '<div class="set2h2rd4xi"><img src="spec/images/jpg/h2rd_l.jpg" alt="H2RD" height="150" width="200" /></div></a>'
# kb2replace [18] = '<div class="set2h2rd4xi"><img src="spec/images/jpg/h2rd_f.jpg" alt="H2RD" height="150" width="200" /></div></a>'
# kb2replace [19] = '<div class="set2h2rd4xi"><img src="spec/images/jpg/h2rd_r.jpg" alt="H2RD" height="150" width="200" /></div></a>'
# # 
# kb2replace [20] = '<div class="set2prd4xi"><img src="spec/images/jpg/prd4b_l.jpg" alt="PRD4B" height="150" width="200" /></div></a>'
# kb2replace [21] = '<div class="set2prd4xi"><img src="spec/images/jpg/prd4p_p.jpg" alt="PRD4P" height="150" width="200" /></div></a>'
# kb2replace [22] = '<div class="set2prd4xi"><img src="spec/images/jpg/prd4w_p.jpg" alt="PRD4W" height="150" width="200" /></div></a>'
# kb2replace [23] = '<div class="set2h2fd4xi"><img src="spec/images/jpg/2h2fd4b_r.jpg" alt="2H2FD4B" height="120" width="160" /></div></a>'
# kb2replace [24] = '<div class="set2h2fd4xi"><img src="spec/images/jpg/2h2fd4p_f.jpg" alt="2H2FD4P" height="120" width="160" /></div></a>'
# kb2replace [25] = '<div class="set2h2fd4xi"><img src="spec/images/jpg/2h2fd4w_l.jpg" alt="2H2FD4W" height="120" width="160" /></div></a>'
# kb2replace [26] = '<div class="set2sphere4xi"><img src="spec/images/jpg/xiball1.jpg" alt="Sphere DragonXi" height="150" width="150" /></div><h3><b>&xi;</b> Multiprocessing4Xi</h3>'
# kb2replace [27] = '<div class="set2sphere4xi"><img src="spec/images/jpg/xiball2.jpg" alt="Sphere DragonXi" height="150" width="150" /></div><h3><b>&xi;</b> Scope4xi</h3>'
# kb2replace [28] = '<div class="set2sphere4xi"><img src="spec/images/jpg/xiball3.jpg" alt="Sphere DragonXi" height="150" width="150" /></div><h3><b>&xi;</b> Studio4xi</h3>'
# kb2replace [29] = '<div class="set2surfer4xi"><img src="spec/images/png/surfer.png" alt="Surfer DragonXi" height="150" width="150" /></div></a>'
# # 
# kb2replace [30] = '<div class="set2sphere4xi"><img src="spec/images/jpg/xiball1.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [31] = '<div class="set2sphere4xi"><img src="spec/images/jpg/xiball3.jpg" alt="Sphere DragonXi" height="150" width="150" /></div>'
# kb2replace [32] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cbo.jpg" alt="Icon CBO" height="100" width="73" /></div>'
# kb2replace [33] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cco.jpg" alt="Icon CCO" height="100" width="73" /></div>'
# kb2replace [34] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cdo.jpg" alt="Icon CDO" height="100" width="73" /></div>'
# kb2replace [35] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_ceo.jpg" alt="Icon CEO" height="100" width="73" /></div>'
# kb2replace [36] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cfo.jpg" alt="Icon CFO" height="100" width="73" /></div>'
# kb2replace [37] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cmo.jpg" alt="Icon CMO" height="100" width="73" /></div>'
# kb2replace [38] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cpo.jpg" alt="Icon CPO" height="100" width="73" /></div>'
# kb2replace [39] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_cto.jpg" alt="Icon CTO" height="100" width="73" /></div>'
# # 
# kb2replace [40] = '<div class="set2email4xi"><img src="spec/images/jpg/xi_icons_sec.jpg" alt="Icon SEC" height="100" width="73" /></div>'
# kb2replace [41] = '<div class="set2logo4xi"><img src="spec/images/png/dragonxi.png" alt="DragonXi" height="105" width="210" /></div></a>'
# kb2replace [42] = '<div class="set2goldengate4xi"><img src="spec/images/jpg/goldengate.jpg" alt="Golden Gate" height="124" width="210" /></div></a>'

# --------
# RUN 14
# --------
# kb2replace [1] = '<h3> <b>&xi;</b> Contact to learn more:</h3>'

# --------
# RUN 13
# --------
# kb2replace [1] = '<h3> <b>&xi;</b> <b>Contact to learn more:</h3>'

# --------
# RUN 12
# --------
# kb2replace [1] = '<img src="spec/images/png/dragonxi.png" alt="DragonXi"'
# kb2replace [2] = '<img src="spec/images/png/net_business.png" alt="NET Business"'
# kb2replace [3] = '<img src="spec/images/png/pod_bus_01.png" alt="Pod Business"'
# kb2replace [4] = '<img src="spec/images/png/xi_bus_04.png" alt="Xi Business"'
# kb2replace [5] = '<img src="spec/images/png/net_patrol.png" alt="NET Patrol"'
# kb2replace [6] = '<img src="spec/images/png/pod_pat_01.png" alt="Pod Patrol"'
# kb2replace [7] = '<img src="spec/images/png/xi_pat_07.png" alt="Xi Patrol"'
# kb2replace [8] = '<img src="spec/images/png/net_military.png" alt="NET Military"'
# kb2replace [9] = '<img src="spec/images/png/pod_mil_01.png" alt="Pod Military"'
# 
# kb2replace [10] = '<img src="spec/images/png/xi_mil_01.png" alt="Xi Military"'
# kb2replace [11] = '<img src="spec/images/png/base_bus_03.png" alt="Base Business"'
# kb2replace [12] = '<img src="spec/images/png/base_pat_02.png" alt="Base Patrol"'
# kb2replace [13] = '<img src="spec/images/png/base_mil_01.png" alt="Base Military"'
# kb2replace [14] = '<img src="spec/images/png/sensor_bus_01.png" alt="Sensor Business"'
# kb2replace [15] = '<img src="spec/images/png/sensor_pat_01.png" alt="Sensor Patrol"'
# kb2replace [16] = '<img src="spec/images/png/sensor_mil_01.png" alt="Sensor Military"'
# kb2replace [17] = '<img src="spec/images/jpg/h2rd_l.jpg" alt="H2RD"'
# kb2replace [18] = '<img src="spec/images/jpg/h2rd_f.jpg" alt="H2RD"'
# kb2replace [19] = '<img src="spec/images/jpg/h2rd_r.jpg" alt="H2RD"'
# 
# kb2replace [20] = '<img src="spec/images/jpg/prd4b_l.jpg" alt="PRD4B"'
# kb2replace [21] = '<img src="spec/images/jpg/prd4p_p.jpg" alt="PRD4P"'
# kb2replace [22] = '<img src="spec/images/jpg/prd4w_p.jpg" alt="PRD4W"'
# kb2replace [23] = '<img src="spec/images/jpg/2h2fd4b_r.jpg" alt="2H2FD4B"'
# kb2replace [24] = '<img src="spec/images/jpg/2h2fd4p_f.jpg" alt="2H2FD4P"'
# kb2replace [25] = '<img src="spec/images/jpg/2h2fd4w_l.jpg" alt="2H2FD4W"'
# kb2replace [26] = '<img src="spec/images/jpg/xiball1.jpg" alt="Sphere DragonXi"'
# kb2replace [27] = '<img src="spec/images/jpg/xiball2.jpg" alt="Sphere DragonXi"'
# kb2replace [28] = '<img src="spec/images/jpg/xiball3.jpg" alt="Sphere DragonXi"'
# kb2replace [29] = '<img src="spec/images/png/surfer.png" alt="Surfer DragonXi"'
# 
# kb2replace [30] = '<img src="spec/images/jpg/xi_icons_cbo.jpg" alt="Icon CBO"'
# kb2replace [31] = '<img src="spec/images/jpg/xi_icons_cco.jpg" alt="Icon CCO"'
# kb2replace [32] = '<img src="spec/images/jpg/xi_icons_cdo.jpg" alt="Icon CDO"'
# kb2replace [33] = '<img src="spec/images/jpg/xi_icons_ceo.jpg" alt="Icon CEO"'
# kb2replace [34] = '<img src="spec/images/jpg/xi_icons_cfo.jpg" alt="Icon CFO"'
# kb2replace [35] = '<img src="spec/images/jpg/xi_icons_cmo.jpg" alt="Icon CMO"'
# kb2replace [36] = '<img src="spec/images/jpg/xi_icons_cpo.jpg" alt="Icon CPO"'
# kb2replace [37] = '<img src="spec/images/jpg/xi_icons_cto.jpg" alt="Icon CTO"'
# kb2replace [38] = '<img src="spec/images/jpg/xi_icons_sec.jpg" alt="Icon SEC"'
# kb2replace [39] = '<img src="spec/images/jpg/goldengate.jpg" alt="Golden Gate"'
# 
# kb2replace [40]='<br /> <b>&xi;</b> <b>Contact examples to learn more:</b>'

# --------
# RUN 11
# --------
# kb2replace [1] = '<b>&zeta;</b><sub>b</sub></a>'
# kb2replace [2] = '<b>&zeta;</b><sub>p</sub></a>'
# kb2replace [3] = '<b>&zeta;</b><sub>m</sub></a>'

# --------
# RUN 10
# --------
# kb2replace [1] = '<br /><h3><b>&epsilon;</b> Quantum Computing</h3>'

# --------
# RUN 9
# --------
# kb2replace [1] = '</sub>'

# --------
# RUN 8
# --------
# kb2replace [1] = 'height="150" width="200"'

# --------
# RUN 7
# --------
# kb2replace [1] = '</head>' + '\n' + '<body>' + '\n'

# --------
# RUN 6
# --------
# kb2replace [1] = '<meta charset="UTF-8">'


# --------
# RUN 5
# --------
# kb2replace [1] = '</style>' + '\n' + '</head>' + '\n'

# --------
# RUN 4
# --------
# kb2replace [1] = '<!--'+ '\n'
# kb2replace [2] = '<h3>Categories</h3>'+ '\n'
# kb2replace [3] = '<h3><b>&xi;</b> Multiprocessing4Xi</h3>'+ '\n'
# kb2replace [4] = '<h3><b>&xi;</b> Scope4xi</h3>'+ '\n'
# kb2replace [5] = '<h3><b>&xi;</b> Studio4xi</h3>'+ '\n'
# kb2replace [6] = '      <h3><b>&tau;</b> Artificial Intelligence (AI)</h3>'+ '\n'
# kb2replace [7] = '<br /><h3><b>&Gamma;</b> Autonomous</h3>'+ '\n'
# kb2replace [8] = '<br />      <h3><b>&Phi;</b> Deep Technology</h3>'+ '\n'
# kb2replace [9] = '<br /><h3><b>&Psi;</b> Ocean, Desert, Tepui, Environment</h3>'+ '\n'
# kb2replace [10] = '<br /><h3><b>&nu;</b> Fishing and hunting</h3>'+ '\n'
# kb2replace [11] = '<br /><h3><b>&epsilon;</b> Quantum Computing'+ '\n'
# kb2replace [12] = '<br /><h3><b>&Pi;</b> Science</h3>'+ '\n'
# kb2replace [13] = '<br /><h3><b>&upsilon;</b> Special Vehicles</h3>'+ '\n'
# kb2replace [14] = '<br /><h3><b>&rho;</b> Unmanned</h3>'+ '\n'
# kb2replace [15] = '<br /><h3><b>&rho;</b> Unmanned</h3>'+ '\n'
# kb2replace [16] = '<br /><h3><b>&delta;</b> Wearable</h3>'+ '\n'
# kb2replace [17] = '<br /><h3>All in alphabetical order</h3>'+ '\n'
# kb2replace [18] = '<b>&xi;</b>'+ '\n'
# kb2replace [19] = '<b>&raquo;</b><a href="https://www.machineprogramming.dev" target="_blank">.dev</a>' + '\n' + ' </td>' + '\n'
# kb2replace [20] = ' '
# kb2replace [21] = ' '
# kb2replace [22] = ' '
# kb2replace [23] = ' '
# kb2replace [24] = ' '
# kb2replace [25] = ' '

# kb2replace [22]='<h3>['
# kb2replace [23]=']</h3>'
# kb2replace [24]='<img src='
# kb2replace [25]='<h3><b>&xi;</b> <b>Contact examples to learn more:</h3>'
# kb2replace [26] = ' '

# 3 set
# kb2replace[1]='<b>&raquo;</b><a href="https://www.yourdragonxi.org/halongbay/spec/index_spec.html" target="_blank">Systems</a>'
# 3 set
#        G:\temp\job2studio4xi\out\html\out\aceit_dev\index.html <-- one test input
#        see path2write4xi
#

# 2 set 
# kb2replace[1]='UAS | Artificial Intelligence | AI |'
# kb2replace[2]='unmannedsystem.dev'
# kb2replace[3]='unmannedsystem'

# 1 set
# kb2replace[1]='https://www.yourdragonxi'
# kb2replace[2]='https://www.yourdragonxi'
# kb2replace[3]='https://www.yourdragonxi'
# -----------------------------------------------------------------------------
        
keys2search  = kb2search.keys()
keys2replace = kb2replace.keys()

path2write4xi = None

path2read4xi  = VersionKB4Xi['input2replace4app']   # defines input folder to be walked with all its subfolders
path2write4xi = VersionKB4Xi['output2replace4app']  # defines output folder for savings 

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.html'                      # object types to be fetched
                                             # '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C, 
                                             # '.html', 'xml'

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4replace" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 1A/33) OF SET2TRACE4REPLACE - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 1B/33) OF SET2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4REPLACE - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    if ack2debug is True:
        print('=' *33)
        print("(Step 33/33) OF SET2TRACE4REPLACE - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4replace" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4replace():
    global ack2debug
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if ack2debug is True:
        print("(Step 01A/33) of DENY2TRACE4REPLACE: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 01B/33) OF DENY2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4REPLACE - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4REPLACE - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4REPLACE - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4REPLACE - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4REPLACE *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4REPLACE - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4REPLACE - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    if ack2debug is True:
        print("(Step 033/33) OF SET2TRACE4REPLACE - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global ack2debug
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if ack2debug is True:
        print("(Step 001A/33) OF TAILOR2TRACE4REPLACE - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         # 'walk2replace4app': 'NACK4TRACE' # turn on/off
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if ack2debug is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # Pipe4Xi, Process4Xi, Queue4Xi, walk2replace4app

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    if ack2debug is True:
        print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
        #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
    
    class2print  = "walk2replace4app"
    method2print = "walk2replace4app" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-walk2replace4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2replace4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2replace4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing ofStudio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="yourDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing walk2replace4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">walk2replace4app sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-walk2replace4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2replace4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2replace4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for walk2replace4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-walk2replace4app.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2replace4app.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/sw4xi/python33/xml/walk2replace4app.owl#"\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for walk2replace4app.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of walk2replace4app.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "walk2replace4app" usage = "
#   replaces defined targets from dragon4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def walk2replace4app(target2explore):
    global ack2debug
    global count2skipped
    global count2replaced
    global count2total
    global kb2replace                              # knowledgebase for replacing
    global kb2replace          
    global keys2search
    global keys2replace
     
    global name2create   
    global path2read4xi                            # path for input source targets
    global path2write4xi                           # path for output source targets
    global profile2fetch                           # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "walk2replace4app"
    method2print = "walk2replace4app" 
 
    message2print = "{(Step 0A/33) using" + "; t2xi-using-by-walk2replace4app: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    message2print = "{(Step 1/8) got" + "; target2explore-got-by-walk2replace4app: " + str(target2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\index.html 
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore)
    
    path2input = None    
    if name2target[1] == profile2fetch:
        # html
                  
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF WALK2REPLACE4APP - TARGET ACCORDING TO PROFILE
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; target2explore-analyzing-by-walk2replace4app: " + str(target2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\index.html
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF WALK2REPLACE4APP - INPUT FILE PATH 
        # -----------------------------------------------------------------------------------------
        path2input = name2target[0] + profile2fetch 
        message2print = "{(Step 2A/33) set" + "; path2input-set-by-walk2replace4app to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\index.html

        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2REPLACE4APP - OPEN INPUT FILE
        # -----------------------------------------------------------------------------------------
        file2input = open(path2input,'r')
        message2print = "{(Step 3A/33) opened" + "; file2input-opened-by-walk2replace4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\\index.html
         
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF WALK2REPLACE4APP - OUTPUT FILE NAME 
        # -----------------------------------------------------------------------------------------
        string2skip = '/'
        name2create = path2input
        max2try = 33
        count2try = 0
        while 1:
            index2skip = str.find(name2create,string2skip)
            count2try = count2try + 1
            if (index2skip == -1) or (count2try > max2try):
                break
            else:
                name2create = name2create[index2skip+1:]
                
        message2print = "{(Step 3B/33) set" + "; name2create to: " + str(name2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # app2ace4yo_app\index.html
                
        # -----------------------------------------------------------------------------------------
        # (Step 4/33) OF WALK2REPLACE4APP - OPEN OUTPUT FILE
        # -----------------------------------------------------------------------------------------
        path2output = path2write4xi + name2create
        
        message2print = "{(Step 4A/33) set" + "; path2output-set-by-walk2replace4app to: " + str(path2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # G://temp//job2studio4xi//out//one2ftp4app//app2ace4yo_app\index.html        
        
        file2output = open(path2output,'w') 
        message2print = "{(Step 4B/33) opened" + "; file2output-opened-by-walk2replace4app: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # G://temp//job2studio4xi//out//one2ftp4app//app2ace4yo_app\\index.html    

        while 1:
            # -------------------------------------------------------------------------------------
            # (Step 5/33) OF WALK2REPLACE4APP - PROCESS FILE
            # -------------------------------------------------------------------------------------             
            line2process = file2input.readline()  
            if not line2process:
                # ---------------------------------------------------------------------------------
                # (Step 5/33) OF WALK2REPLACE4APP - ALL LINES READ, FINISH
                # ---------------------------------------------------------------------------------             
                break                                               
            else:
                # ---------------------------------------------------------------------------------
                # (Step 7/33) OF WALK2REPLACE4APP - EXAMINE AND IF NEEDED, PROCESS LINE 
                # ---------------------------------------------------------------------------------
                line2write = line2process
                first2tell = True
                ack2replace = False
                for key in keys2search:
                    # -----------------------------------------------------------------------------
                    # check all strings to be replaced
                    # ----------------------------------------------------------------------------- 
                    string2search = kb2search[key]
                    len2search = len(string2search)
                    
                    string2update = kb2replace[key]
                    len2update = len(string2update)
                    
                    difference2len = len2update - len2search
                        
                    index2replace = str.find(line2write,string2search)
                    if (index2replace == -1):
                        pass
                    else:
                        ack2replace = True
                        if first2tell is True: 
                            message2print = "{(Step 7A/33) got" + "; line2process-got-by-walk2replace4app: " + str(line2process) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # <br /> <b>&Delta;</b> marlingfishing
                            
                            first2tell = False
                              
                        message2print = "{(Step 7B/33) got" + "; string2search-got-by-walk2replace4app: " + str(string2search) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # marling
                        
                        message2print = "{(Step 7C/33) got" + "; string2update-got-by-walk2replace4app: " + str(string2update) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # marlin
                        
                        message2print = "{(Step 7D/33) set" + "; index2replace-set-by-walk2replace4app to: " + str(index2replace) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 22
                        
                        message2print = "{(Step 7E/33) got" + "; begin2write-got-by-walk2replace4app: " + str(line2write[0:index2replace]) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <br /> <b>&Delta;</b>
                        
                        begin2write = line2write[0:index2replace] + string2update
                                                
                        message2print = "{(Step 7H/33) set" + "; begin2write-set-by-walk2replace4app to: " + str(begin2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <br /> <b>&Delta;</b> marlin
                        
                        index2next = index2replace + len2search                      
                        message2print = "{(Step 7I/33) set" + "; index2next-set-by-walk2replace4app to: " + str(index2next) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        line2write = begin2write + line2write[index2next:]
                        
                        message2print = "{(Step 7K/33) set" + "; line2write-set-by-walk2replace4app to: " + str(line2write) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # <br /> <b>&Delta;</b> marlinfishing

                           
            # ---------------------------------------------------------------------------------
            # (Step 29/33) OF WALK2REPLACE4APP - WRITE PROCESSED LINE
            # ---------------------------------------------------------------------------------                           
            if ack2replace is True:
                file2output.write(line2write)
            else:
                file2output.write(line2process)
            
        # -----------------------------------------------------------------------------------------
        # (Step 31/33) OF WALK2REPLACE4APP - CLOSE INPUT
        # -----------------------------------------------------------------------------------------            
        file2input.close()
        message2print = "{(Step 31A/33) closed" + "; file2input-closed-by-walk2replace4app: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        # G://temp//job2studio4xi//in//one2do4app//app2ace4yo_app\\index.html
            
                        
        # -----------------------------------------------------------------------------------------
        # (Step 32/33) OF WALK2REPLACE4APP - CLOSE OUTPUT
        # -----------------------------------------------------------------------------------------            
        file2output.close()
        message2print = "{(Step 31B/33) closed" + "; file2output-closed-by-walk2replace4app: " + str(file2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # G://temp//job2studio4xi//out//one2ftp4app//app2ace4yo_app\\index.html  
            
    else:
        message2print = "{(Step 1E/33) skipped" + "; path2input-skipped-by-walk2replace4app: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # 
            
        count2skipped = count2skipped + 1
        count2total = count2total + 1
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2debug
    global count2skipped
    global count2replaced
    global count2total
    
    global path2read4xi
    global path2write4xi
    global profile2fetch

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if ack2debug is True:
        print("(Step 0A/33) OF MAIN WALK2REPLACE4APP - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2replaced = 0
    count2total  = 0   

    set2trace4replace()                                                                                               # trace all classes and functions in the system
    deny2trace4replace()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 0B/33) OF MAIN WALK2REPLACE4APP - VERSION 4.4 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # 
    
    pipe2fetch = Pipe4Xi()
    if ack2debug is True:
        print("(Step 1A/33) OF MAIN WALK2REPLACE4APP - PIPE2FETCH ", pipe2fetch)    
    
    queue2fetch = Queue4Xi()
    if ack2debug is True:
        print("(Step 1B/33) OF MAIN WALK2REPLACE4APP - QUEUE2FETCH ", queue2fetch)    
    
        print("(Step 1C/33) OF MAIN WALK2REPLACE4APP - PATH2READ4XI ", path2read4xi) 
    
        print("(Step 1D/33) OF MAIN WALK2REPLACE4APP - PATH2WRITE4XI ", path2write4xi)
     
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print("(Step 2A/33) OF MAIN WALK2REPLACE4APP - DIRECTORY: ", file2walk)
            # 
        if os.path.isfile(file2walk):
            walk2replace4app(file2walk)
            
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 3A/33) OF MAIN WALK2REPLACE4APP - VERSION 4.4 - IN: ", path2read4xi, "- OUT: ", path2write4xi," - PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
    # 
            

       
    # ===========================================================================
    print('=' *75)
    
    
     
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    # print ('(Step 1E/33) OF MAIN WALK2REPLACE4APP - PRINTING TRACE WITH T2XI', t2xi)
    # 
    # print_trace4xi(t2xi)        
    # print ('(Step 1F/33) OF MAIN WALK2REPLACE4APP - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# VERSION 3.4 - IN:  G://temp//job2studio4xi//in//html// - OUT:  G://temp//job2studio4xi//out//html//  - PROFILE:  .html  COMPLETED   07:59:17 04/03/19 FLE Daylight Time
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of walk2replace4app.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

